<!--
~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied. See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->
<%@page import="org.opensaml.saml2.core.AuthnRequest" %>
<%@page import="org.opensaml.saml2.core.LogoutRequest" %>
<%@ page
        import="org.wso2.carbon.identity.authenticator.saml2.sso.ui.SAML2SSOAuthenticatorConstants" %>
<%@ page import="org.wso2.carbon.identity.authenticator.saml2.sso.ui.SSOSessionManager" %>
<%@ page
        import="org.wso2.carbon.identity.authenticator.saml2.sso.ui.builders.AuthenticationRequestBuilder" %>
<%@ page
        import="org.wso2.carbon.identity.authenticator.saml2.sso.ui.builders.LogoutRequestBuilder" %>
<%@ page
        import="org.wso2.carbon.identity.authenticator.saml2.sso.ui.Util" %>
<%@ page import="org.wso2.carbon.registry.core.utils.UUIDGenerator" %>
<%@ page import="org.wso2.carbon.utils.multitenancy.MultitenantConstants" %>
<html>
<head>
    <link media="all" type="text/css" rel="stylesheet"
          href="../stratos-auth/css/stratos-loginpage.css"/>
    <title>WSO2 Stratos Identity</title>
    <style type="text/css" media="screen"><!--
body {
	color:#111111;
	font-family:"Calibri","Lucida Grande","Lucida Sans","Microsoft Sans Serif","Lucida Sans Unicode","Verdana","Sans-serif","trebuchet ms" !important;
	font-size:0.75em;
	font-size-adjust:none;
	font-style:normal;
	font-variant:normal;
	font-weight:normal;
	line-height:1.25em;
	background-color: #D5EDFB;
	margin: 0px;
	padding: 0px;
}
div.header {
	background-color: #D5EDFB;
	margin: auto;
	margin-top: 0px;
	text-align: center;
	font-size: 375%;
	line-height: 250%;
	font-weight: bold;
	height: 120px;
	padding-top: 70px;
}
div.header span.wso2 {
	color: #f47b20;
}
div.middle {
	background-color: #ffffff;
	border-bottom: solid 1px #8BD2F4;
	border-top: solid 1px #8BD2F4;
}
div.middle div.message {
	width: 600px;
	margin: auto;
	padding-top: 30px;
	padding-bottom: 30px;
	font-size: 130%;
	line-height: 140%;
	text-align: center;
}
div.footer {
	width: 600px;
	margin: auto;
	height: 100px;
	background-color: #D5EDFB;
}
.link-button{
	border:none;
	background:transparent;
	cursor:pointer;
	color:#437793;
	text-decoration:underline;
	font-size:120%;
}
.redirectForm{
	display:inline;
}
--></style>
</head>
<body>
<%
    String encodedReq = null;
    String relayState = "";
    String domain = null;
    if (request.getParameter(SAML2SSOAuthenticatorConstants.LOG_OUT_REQ) != null) {
        LogoutRequestBuilder logoutRequestBuilder = new LogoutRequestBuilder();
        LogoutRequest logoutReq = logoutRequestBuilder.buildLogoutRequest((String) request.getAttribute(
                SAML2SSOAuthenticatorConstants.LOGGED_IN_USER), SAML2SSOAuthenticatorConstants.LOGOUT_USER);
        encodedReq = Util.encode(Util.marshall(logoutReq));
        relayState = UUIDGenerator.generateUUID();
    } else {
        AuthenticationRequestBuilder authnReqGenerator = new AuthenticationRequestBuilder();
        AuthnRequest authRequest = authnReqGenerator.buildAuthenticationRequest(null);
        encodedReq = Util.encode(Util.marshall(authRequest));
        relayState = UUIDGenerator.generateUUID();
        domain = (String) request.getAttribute(MultitenantConstants.TENANT_DOMAIN);
    }
    // add the relay state to Session Manager
    SSOSessionManager.addAuthnRequest(relayState);

%>
<div class="header">
	<span class="wso2">WSO2</span> Stratos Services
</div>
<div class="middle">
	<div class="message">
		You are now redirected to <%=Util.getIdentityProviderSSOServiceURL().substring(0, Util.getIdentityProviderSSOServiceURL().lastIndexOf("/"))%><br/>If the
		redirection fails, please click 
		<form method="post" action="<%=Util.getIdentityProviderSSOServiceURL()%>" class="redirectForm">
	            <input type="hidden"
	                      name="<%=SAML2SSOAuthenticatorConstants.HTTP_POST_PARAM_SAML2_AUTH_REQ%>"
	                      value="<%= encodedReq %>"/>
	                <input type="hidden" name="RelayState" value="<%= relayState %>"/>
	                <input type="hidden" name="<%= MultitenantConstants.TENANT_DOMAIN %>"
	                       value="<%= domain %>"/>
	                <input type="hidden" name="<%= MultitenantConstants.SSO_AUTH_SESSION_ID %>" value="<%= session.getId() %>"/>
	                <input type="submit" class="link-button" value="here" />
	        </form>
	</div>
	<script type="text/javascript">
    		document.forms[0].submit();
	</script>
</div>
</body>
</html>
